Panda3D

Public Types | Public Member Functions | Static Public Member Functions | Friends | List of all members
BitArray Class Reference

A dynamic array with an unlimited number of bits. More...

`#include "bitArray.h"`

## Public Types
enum | { num_bits_per_word = MaskType::num_bits }
typedef BitMaskNative | MaskType
typedef MaskType::WordType | WordType

## Public Member Functions
| BitArray (const SparseArray &from)
| BitArray (WordType init_value)
void | clear ()
| Sets all the bits in the BitArray off. More...
void | clear_bit (int index)
| Sets the nth bit off. More...
void | clear_range (int low_bit, int size)
| Sets the indicated range of bits off. More...
int | compare_to (const BitArray &other) const
| Returns a number less than zero if this BitArray sorts before the indicated other BitArray, greater than zero if it sorts after, or 0 if they are equivalent. More...
WordType | extract (int low_bit, int size) const
| Returns a word that represents only the indicated range of bits within this BitArray, shifted to the least-significant position. More...
void | generate_hash (ChecksumHashGenerator &hashgen) const
| Adds the bitmask to the indicated hash generator. More...
bool | get_bit (int index) const
| Returns true if the nth bit is set, false if it is cleared. More...
bool | get_highest_bits () const
| Returns true if the infinite set of bits beyond get_num_bits() are all on, or false of they are all off. More...
int | get_highest_off_bit () const
| Returns the index of the highest 0 bit in the array. More...
int | get_highest_on_bit () const
| Returns the index of the highest 1 bit in the array. More...
int | get_lowest_off_bit () const
| Returns the index of the lowest 0 bit in the array. More...
int | get_lowest_on_bit () const
| Returns the index of the lowest 1 bit in the array. More...
int | get_next_higher_different_bit (int low_bit) const
| Returns the index of the next bit in the array, above low_bit, whose value is different that the value of low_bit. More...
size_t | get_num_bits () const
| Returns the current number of possibly different bits in this array. More...
int | get_num_off_bits () const
| Returns the number of bits that are set to 0 in the array. More...
int | get_num_on_bits () const
| Returns the number of bits that are set to 1 in the array. More...
size_t | get_num_words () const
| Returns the number of possibly-unique words stored in the array. More...
MaskType | get_word (size_t n) const
| Returns the nth word in the array. More...
bool | has_all_of (int low_bit, int size) const
| Returns true if all bits in the indicated range are set, false otherwise. More...
bool | has_any_of (int low_bit, int size) const
| Returns true if any bit in the indicated range is set, false otherwise. More...
bool | has_bits_in_common (const BitArray &other) const
| Returns true if this BitArray has any "one" bits in common with the other one, false otherwise. More...
void | invert_in_place ()
| Inverts all the bits in the BitArray. More...
bool | is_all_on () const
| Returns true if the entire bitmask is one, false otherwise. More...
bool | is_zero () const
| Returns true if the entire bitmask is zero, false otherwise. More...
bool | operator!= (const BitArray &other) const
BitArray | operator& (const BitArray &other) const
void | operator&= (const BitArray &other)
bool | operator< (const BitArray &other) const
| Returns true if the unsigned integer which is represented by this BitArray is less than that of the other one, false otherwise. More...
BitArray | operator<< (int shift) const
void | operator<<= (int shift)
| Logical left shift. More...
bool | operator== (const BitArray &other) const
BitArray | operator>> (int shift) const
void | operator>>= (int shift)
| Logical right shift. More...
BitArray | operator^ (const BitArray &other) const
void | operator^= (const BitArray &other)
BitArray | operator| (const BitArray &other) const
void | operator|= (const BitArray &other)
BitArray | operator~ () const
void | output (std::ostream &out) const
| Writes the BitArray out as a hex number. More...
void | output_binary (std::ostream &out, int spaces_every=4) const
| Writes the BitArray out as a binary number, with spaces every four bits. More...
void | output_hex (std::ostream &out, int spaces_every=4) const
| Writes the BitArray out as a hexadecimal number, with spaces every four digits. More...
void | read_datagram (DatagramIterator &scan, BamReader *manager)
| Reads the object that was previously written to a Bam file. More...
void | set_bit (int index)
| Sets the nth bit on. More...
void | set_bit_to (int index, bool value)
| Sets the nth bit either on or off, according to the indicated bool value. More...
void | set_range (int low_bit, int size)
| Sets the indicated range of bits on. More...
void | set_range_to (bool value, int low_bit, int size)
| Sets the indicated range of bits to either on or off. More...
void | set_word (size_t n, WordType value)
| Replaces the nth word in the array. More...
void | store (WordType value, int low_bit, int size)
| Stores the indicated word into the indicated range of bits with this BitArray. More...
void | write (std::ostream &out, int indent_level=0) const
| Writes the BitArray out as a binary or a hex number, according to the number of bits. More...
void | write_datagram (BamWriter *manager, Datagram &dg) const
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...

## Static Public Member Functions
static BitArray | all_off ()
| Returns a BitArray whose bits are all off. More...
static BitArray | all_on ()
| Returns a BitArray with an infinite array of bits, all on. More...
static BitArray | bit (int index)
| Returns a BitArray with only the indicated bit on. More...
static TypeHandle | get_class_type ()
constexpr static int | get_max_num_bits ()
constexpr static int | get_num_bits_per_word ()
constexpr static bool | has_max_num_bits ()
static void | init_type ()
static BitArray | lower_on (int on_bits)
| Returns a BitArray whose lower on_bits bits are on. More...
static BitArray | range (int low_bit, int size)
| Returns a BitArray whose size bits, beginning at low_bit, are on. More...

## Friends
class | Extension< BitArray >

## Detailed Description

A dynamic array with an unlimited number of bits.

This is similar to a BitMask, except it appears to contain an infinite number of bits. You can use it very much as you would use a BitMask.

Definition at line 40 of file bitArray.h.

## Member Function Documentation

## ◆ all_off()

BitArray BitArray::all_off | ( |  | ) |
| inline static

Returns a BitArray whose bits are all off.

Definition at line 46 of file bitArray.I.

## ◆ all_on()

BitArray BitArray::all_on | ( |  | ) |
| inline static

Returns a BitArray with an infinite array of bits, all on.

Definition at line 36 of file bitArray.I.

## ◆ bit()

BitArray BitArray::bit | ( | int | index | ) |
| inline static

Returns a BitArray with only the indicated bit on.

Definition at line 64 of file bitArray.I.

## ◆ clear()

void BitArray::clear | ( |  | ) |
| inline

Sets all the bits in the BitArray off.

Definition at line 271 of file bitArray.I.

## ◆ clear_bit()

void BitArray::clear_bit | ( | int | index | ) |
| inline

Sets the nth bit off.

If n >= get_num_bits(), this automatically extends the array.

Definition at line 132 of file bitArray.I.

## ◆ clear_range()

void BitArray::clear_range | ( | int | low_bit,
|  | int | size
| ) |  |

Sets the indicated range of bits off.

Definition at line 244 of file bitArray.cxx.

References get_num_words().

## ◆ compare_to()

int BitArray::compare_to | ( | const BitArray & | other | ) | const

Returns a number less than zero if this BitArray sorts before the indicated other BitArray, greater than zero if it sorts after, or 0 if they are equivalent.

This is based on the same ordering defined by operator <.

Definition at line 581 of file bitArray.cxx.

References get_num_words().

## ◆ extract()

BitArray::WordType BitArray::extract | ( | int | low_bit,
|  | int | size
| ) |  | const
| inline

Returns a word that represents only the indicated range of bits within this BitArray, shifted to the least-significant position.

size must be <= get_num_bits_per_word().

Definition at line 172 of file bitArray.I.

## ◆ generate_hash()

void BitArray::generate_hash | ( | ChecksumHashGenerator & | hashgen | ) | const

Adds the bitmask to the indicated hash generator.

Definition at line 854 of file bitArray.cxx.

References ChecksumHashGenerator::add_int().

## ◆ get_bit()

bool BitArray::get_bit | ( | int | index | ) | const
| inline

Returns true if the nth bit is set, false if it is cleared.

It is valid for n to increase beyond get_num_bits(), but the return value get_num_bits() will always be the same.

Definition at line 98 of file bitArray.I.

Referenced by get_next_higher_different_bit().

## ◆ get_highest_bits()

bool BitArray::get_highest_bits | ( |  | ) | const
| inline

Returns true if the infinite set of bits beyond get_num_bits() are all on, or false of they are all off.

Definition at line 162 of file bitArray.I.

## ◆ get_highest_off_bit()

int BitArray::get_highest_off_bit | ( |  | ) | const

Returns the index of the highest 0 bit in the array.

Returns -1 if there are no 0 bits or if there an infinite number of 1 bits.

Definition at line 390 of file bitArray.cxx.

References get_num_words().

## ◆ get_highest_on_bit()

int BitArray::get_highest_on_bit | ( |  | ) | const

Returns the index of the highest 1 bit in the array.

Returns -1 if there are no 1 bits or if there an infinite number of 1 bits.

Definition at line 371 of file bitArray.cxx.

References get_num_words().

## ◆ get_lowest_off_bit()

int BitArray::get_lowest_off_bit | ( |  | ) | const

Returns the index of the lowest 0 bit in the array.

Returns -1 if there are no 0 bits.

Definition at line 351 of file bitArray.cxx.

References get_num_words().

## ◆ get_lowest_on_bit()

int BitArray::get_lowest_on_bit | ( |  | ) | const

Returns the index of the lowest 1 bit in the array.

Returns -1 if there are no 1 bits.

Definition at line 331 of file bitArray.cxx.

References get_num_words().

## ◆ get_next_higher_different_bit()

int BitArray::get_next_higher_different_bit | ( | int | low_bit | ) | const

Returns the index of the next bit in the array, above low_bit, whose value is different that the value of low_bit.

Returns low_bit again if all bits higher than low_bit have the same value.

This can be used to quickly iterate through all of the bits in the array.

Definition at line 412 of file bitArray.cxx.

References get_bit(), and get_num_words().

## ◆ get_num_bits()

size_t BitArray::get_num_bits | ( |  | ) | const
| inline

Returns the current number of possibly different bits in this array.

There are actually an infinite number of bits, but every bit higher than this bit will have the same value, either 0 or 1 (see get_highest_bits()).

This number may grow and/or shrink automatically as needed.

Definition at line 88 of file bitArray.I.

Referenced by has_all_of(), has_any_of(), output_binary(), and output_hex().

## ◆ get_num_off_bits()

int BitArray::get_num_off_bits | ( |  | ) | const

Returns the number of bits that are set to 0 in the array.

Returns -1 if there are an infinite number of 0 bits.

Definition at line 313 of file bitArray.cxx.

## ◆ get_num_on_bits()

int BitArray::get_num_on_bits | ( |  | ) | const

Returns the number of bits that are set to 1 in the array.

Returns -1 if there are an infinite number of 1 bits.

Definition at line 295 of file bitArray.cxx.

## ◆ get_num_words()

size_t BitArray::get_num_words | ( |  | ) | const
| inline

Returns the number of possibly-unique words stored in the array.

Definition at line 234 of file bitArray.I.

Referenced by clear_range(), compare_to(), get_highest_off_bit(), get_highest_on_bit(), get_lowest_off_bit(), get_lowest_on_bit(), get_next_higher_different_bit(), has_all_of(), has_any_of(), and set_range().

## ◆ get_word()

BitArray::MaskType BitArray::get_word | ( | size_t | n | ) | const
| inline

Returns the nth word in the array.

It is valid for n to be greater than get_num_words(), but the return value beyond get_num_words() will always be the same.

Definition at line 244 of file bitArray.I.

Referenced by has_all_of(), and has_any_of().

## ◆ has_all_of()

bool BitArray::has_all_of | ( | int | low_bit,
|  | int | size
| ) |  | const

Returns true if all bits in the indicated range are set, false otherwise.

Definition at line 141 of file bitArray.cxx.

References get_num_bits(), get_num_words(), get_word(), and is_all_on().

## ◆ has_any_of()

bool BitArray::has_any_of | ( | int | low_bit,
|  | int | size
| ) |  | const

Returns true if any bit in the indicated range is set, false otherwise.

Definition at line 88 of file bitArray.cxx.

References get_num_bits(), get_num_words(), get_word(), and is_zero().

## ◆ has_bits_in_common()

bool BitArray::has_bits_in_common | ( | const BitArray & | other | ) | const

Returns true if this BitArray has any "one" bits in common with the other one, false otherwise.

This is equivalent to (array & other) != 0, but may be faster.

Definition at line 466 of file bitArray.cxx.

## ◆ invert_in_place()

void BitArray::invert_in_place | ( |  | ) |

Inverts all the bits in the BitArray.

This is equivalent to array = ~array.

Definition at line 450 of file bitArray.cxx.

## ◆ is_all_on()

bool BitArray::is_all_on | ( |  | ) | const

Returns true if the entire bitmask is one, false otherwise.

Definition at line 68 of file bitArray.cxx.

Referenced by has_all_of().

## ◆ is_zero()

bool BitArray::is_zero | ( |  | ) | const

Returns true if the entire bitmask is zero, false otherwise.

Definition at line 47 of file bitArray.cxx.

Referenced by has_any_of().

## ◆ lower_on()

BitArray BitArray::lower_on | ( | int | on_bits | ) |
| inline static

Returns a BitArray whose lower on_bits bits are on.

Definition at line 54 of file bitArray.I.

## ◆ operator<()

bool BitArray::operator< | ( | const BitArray & | other | ) | const
| inline

Returns true if the unsigned integer which is represented by this BitArray is less than that of the other one, false otherwise.

Definition at line 297 of file bitArray.I.

## ◆ operator<<=()

void BitArray::operator<<= | ( | int | shift | ) |

Logical left shift.

The rightmost bits are filled in with zeroes. Since this is an infinite bit array, none of the bits on the left are lost.

Definition at line 726 of file bitArray.cxx.

References operator>>=().

Referenced by operator>>=().

## ◆ operator>>=()

void BitArray::operator>>= | ( | int | shift | ) |

Logical right shift.

The rightmost bits are lost. Since this is an infinite bit array, there is no question of sign extension; there is no need to synthesize bits on the left.

Definition at line 791 of file bitArray.cxx.

References operator<<=().

Referenced by operator<<=().

## ◆ output()

void BitArray::output | ( | std::ostream & | out | ) | const

Writes the BitArray out as a hex number.

For a BitArray, this is always the same as output_hex(); it's too confusing for the output format to change back and forth at runtime.

Definition at line 519 of file bitArray.cxx.

References output_hex().

## ◆ output_binary()

void BitArray::output_binary | ( | std::ostream & | out,
|  | int | spaces_every = `4`
| ) |  | const

Writes the BitArray out as a binary number, with spaces every four bits.

Definition at line 527 of file bitArray.cxx.

References get_num_bits().

## ◆ output_hex()

void BitArray::output_hex | ( | std::ostream & | out,
|  | int | spaces_every = `4`
| ) |  | const

Writes the BitArray out as a hexadecimal number, with spaces every four digits.

Definition at line 545 of file bitArray.cxx.

References get_num_bits().

Referenced by output().

## ◆ range()

BitArray BitArray::range | ( | int | low_bit,
|  | int | size
| ) |  |
| inline static

Returns a BitArray whose size bits, beginning at low_bit, are on.

Definition at line 74 of file bitArray.I.

## ◆ read_datagram()

void BitArray::read_datagram | ( | DatagramIterator & | scan,
|  | BamReader * | manager
| ) |  |

Reads the object that was previously written to a Bam file.

Definition at line 923 of file bitArray.cxx.

References DatagramIterator::get_uint32().

## ◆ set_bit()

void BitArray::set_bit | ( | int | index | ) |
| inline

Sets the nth bit on.

If n >= get_num_bits(), this automatically extends the array.

Definition at line 114 of file bitArray.I.

## ◆ set_bit_to()

void BitArray::set_bit_to | ( | int | index,
|  | bool | value
| ) |  |
| inline

Sets the nth bit either on or off, according to the indicated bool value.

Definition at line 149 of file bitArray.I.

## ◆ set_range()

void BitArray::set_range | ( | int | low_bit,
|  | int | size
| ) |  |

Sets the indicated range of bits on.

Definition at line 194 of file bitArray.cxx.

References get_num_words().

## ◆ set_range_to()

void BitArray::set_range_to | ( | bool | value,
|  | int | low_bit,
|  | int | size
| ) |  |
| inline

Sets the indicated range of bits to either on or off.

Definition at line 222 of file bitArray.I.

## ◆ set_word()

void BitArray::set_word | ( | size_t | n,
|  | WordType | value
| ) |  |
| inline

Replaces the nth word in the array.

If n >= get_num_words(), this automatically extends the array.

Definition at line 261 of file bitArray.I.

## ◆ store()

void BitArray::store | ( | WordType | value,
|  | int | low_bit,
|  | int | size
| ) |  |
| inline

Stores the indicated word into the indicated range of bits with this BitArray.

Definition at line 196 of file bitArray.I.

## ◆ write()

void BitArray::write | ( | std::ostream & | out,
|  | int | indent_level = `0`
| ) |  | const

Writes the BitArray out as a binary or a hex number, according to the number of bits.

Definition at line 571 of file bitArray.cxx.

References indent().

## ◆ write_datagram()

void BitArray::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg
| ) |  | const

Writes the contents of this object to the datagram for shipping out to a Bam file.

Definition at line 910 of file bitArray.cxx.

References Datagram::add_uint32(), and Datagram::add_uint8().

The documentation for this class was generated from the following files:

- panda/src/putil/bitArray.h
- panda/src/putil/bitArray.cxx
- panda/src/putil/bitArray.I